/*
 * Squawk messenger.
 * Copyright (C) 2019  Yury Gubich <blue@macaw.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <stdexcept>

#include <QByteArray>
#include <QString>

namespace Core {

class Jammer {
public:
    static QString encrypt(const QString& plaintext, qint64 key);
    static QString decrypt(const QString& ciphertext, qint64 key);

private:
    Jammer() = delete;

    static QByteArray process(const QByteArray& input, const QByteArray& key, bool encrypt);
    static QByteArray intToKey(qint64 key, int keySize = 32);

    static unsigned char* toUChar(QByteArray& data);
    static const unsigned char* toUChar(const QByteArray& data);
    static std::string getOpenSSLErrorString();
};

}
